//

const wapper = document.querySelector(".wapper"),  
        musicImg = wapper.querySelector(".img-area img"),  
        musicName = wapper.querySelector(".song-details .name"),  
        musicArtist = wapper.querySelector(".song-details .artist"),  
        mainAudio = wapper.querySelector("#main-audio"),
        playPauseBtn = wapper.querySelector(".play-pause"),
        prevBtn = wapper.querySelector("#prev"),
        nextBtn = wapper.querySelector("#next"),
        progressArea = wapper.querySelector(".progress-area"),
        progressBar = wapper.querySelector(".progress-bar");
const musicList = wapper.querySelector(".music-list"),
        showMoreBtn = wapper.querySelector("#more-music"),
        hideMoreBtn = musicList.querySelector("#close");

let musicIndex = 0;
let isMisicPaused = false;

window.addEventListener("load", ()=>{
    if (allMusic.length) {
        loadPlaylist();
        loadMusic(musicIndex);
    }
});

function loadMusic(indexNumb) {
    musicName.innerText = allMusic[indexNumb].name;
    musicArtist.innerText = allMusic[indexNumb].artist;
    musicImg.src = allMusic[indexNumb].img;
    //mainAudio.src = `./public/home/songs/${allMusic[indexNumb].src}`;
    mainAudio.src = `http://cavs.ipdisk.co.kr:8080/publist/HDD1/Data/cd-mp3/${allMusic[indexNumb].src}`;
    // playlist
    const allTags = ulTag.querySelectorAll(`li`);
    allTags.forEach(li=>{ li.classList.remove("playing")});
    // add "playing"
    const liTags = ulTag.querySelector(`#songs-index-${indexNumb}`);
    if (liTags) {
        liTags.classList.add("playing");    
    }
}
function playMisic() {
    wapper.classList.add("paused");
    playPauseBtn.querySelector("i").innerText = "pause";
    mainAudio.play();
}
function pauseMisic() {
    wapper.classList.remove("paused");
    playPauseBtn.querySelector("i").innerText = "play_arrow";
    mainAudio.pause();
}
function prevMisic() {
    if (isMisicPaused)
        pauseMisic();
    musicIndex  = (musicIndex) ? musicIndex-=1 : allMusic.length - 1;
    loadMusic(musicIndex);
    playMisic();
}
function nextMisic() {
    if (isMisicPaused)
        pauseMisic();
    musicIndex = (musicIndex < allMusic.length - 1) ? musicIndex += 1 : 0;
    loadMusic(musicIndex);
    playMisic();
}

playPauseBtn.addEventListener("click", ()=>{
    isMisicPaused = wapper.classList.contains("paused");
    isMisicPaused ? pauseMisic() : playMisic();
});
prevBtn.addEventListener("click", ()=>{
    prevMisic();
});
nextBtn.addEventListener("click", ()=>{
    nextMisic();
});
mainAudio.addEventListener("timeupdate",(e)=>{
    //console.log(e);
    let time = parseInt(e.target.currentTime);
    let progressWidth = (time / parseInt(e.target.duration)) * 100;
    progressBar.style.width = `${progressWidth}%`;
    // update currentTime
    let currentTime = wapper.querySelector(".current");
    let m = Math.floor(time / 60).toString();
    let s = Math.floor(time % 60).toString().padStart(2,'0');
    currentTime.innerText = `${m}:${s}`;

    mainAudio.addEventListener("loadeddata", ()=>{
        let durationTime = wapper.querySelector(".duration");
        let m = Math.floor(mainAudio.duration / 60).toString();
        let s = Math.floor(mainAudio.duration % 60).toString().padStart(2,'0');
        durationTime.innerText = `${m}:${s}`;
        // init currentTime
        let currentTime = wapper.querySelector(".current");
        currentTime.innerText = `0:00`;
        progressBar.style.width = `0%`;
    });
});
mainAudio.addEventListener("ended",()=>{
    let getText = repeatBtn.innerText;
    switch(getText) {
    case "repeat" : 
        nextMisic();
        break;
    case "repeat_one" : 
        mainAudio.currentTime = 0;
        loadMusic(musicIndex);
        playMisic();
        break;
    case "shuffle" : 
        let randIndex = Math.floor(Math.random() * allMusic.length);
        do {
            randIndex = Math.floor(Math.random() * allMusic.length);
        } while(musicIndex == randIndex)
        musicIndex = randIndex;
        loadMusic(musicIndex);
        playMisic();
        break;
    }
});

progressArea.addEventListener("click", (e)=>{
    if (mainAudio.duration) {
        let range = progressArea.clientWidth;
        let pos = e.offsetX;
        mainAudio.currentTime = (pos / range) * mainAudio.duration;
        playMisic();
    }
});

const repeatBtn = wapper.querySelector("#repeat-plist");
repeatBtn.addEventListener('click', ()=>{
    let getText = repeatBtn.innerText;
    switch(getText) {
        case "repeat" : 
            repeatBtn.innerText = "repeat_one";
            repeatBtn.setAttribute("title", "Song looped"); 
            break;
        case "repeat_one" : 
            repeatBtn.innerText = "shuffle"; 
            repeatBtn.setAttribute("title", "Song shuffle"); 
            break;
        case "shuffle" : 
            repeatBtn.innerText = "repeat"; 
            repeatBtn.setAttribute("title", "Playlist looped"); 
            break;
    }
});

showMoreBtn.addEventListener('click', ()=>{
    musicList.classList.toggle("show");
});
hideMoreBtn.addEventListener('click', ()=>{
    showMoreBtn.click();
});

const ulTag = wapper.querySelector("ul");
function loadPlaylist() {
    ulTag.innerHTML = '';
    // <audio src="./public/home/songs/${item.src}"></audio> 
    // <audio src="http://cavs.ipdisk.co.kr:8080/publist/HDD1/Data/cd-mp3/${item.src}"></audio> 
    allMusic.forEach((item, i)=>{
    let liTag = 
        `<li onclick="songs_clicked(this);" id="songs-index-${i}">
            <div class="row">
                <span>${item.name}</span>
                <p>${item.artist}</p>
            </div>
            <audio src="http://cavs.ipdisk.co.kr:8080/publist/HDD1/Data/cd-mp3/${item.src}"></audio> 
            <span class="audio-duration">3:40</span>
        </li>`;
        ulTag.insertAdjacentHTML("beforeend", liTag);
    
        let audioTag = ulTag.querySelector(`#songs-index-${i} > audio`);
        let durationTag = ulTag.querySelector(`#songs-index-${i} > span`);
        audioTag.addEventListener("loadeddata", ()=>{
            let m = Math.floor(audioTag.duration / 60).toString();
            let s = Math.floor(audioTag.duration % 60).toString().padStart(2,'0');
            durationTag.innerText = `${m}:${s}`;
        })
    });
}

function songs_clicked(e) {
    // playing
    let index = e.getAttribute("id").split('-')[2];
    musicIndex = parseInt(index);
    loadMusic(musicIndex);
    playMisic();
}